using IdentityModel;
using Microsoft.AspNetCore.Http;
using System.Linq;
using System.Security.Claims;
using Aurora.Infrastructure.Tenant;

namespace Aurora.Common.Tenant
{

    public class CurrentTenantProvider : ICurrentTenantProvider
    {
        private CurrentTenant currentTenant { get; set; }

        IHttpContextAccessor httpContextAccessor;
        public CurrentTenantProvider(IHttpContextAccessor _httpContextAccessor)
        {
            httpContextAccessor = _httpContextAccessor;
        }

        public ICurrentTenant GetCurrentTenant()
        {
            CurrentTenant _currentTenant = new CurrentTenant();
            if (httpContextAccessor.HttpContext == null) //cap
            {
                //todo
                _currentTenant = currentTenant;
            }
            else if (httpContextAccessor.HttpContext.User != null &&
                httpContextAccessor.HttpContext.User.Identity.IsAuthenticated) //external
            {
                ClaimsPrincipal claimsPrincipal = httpContextAccessor.HttpContext.User;
                var subject = claimsPrincipal.Claims.FirstOrDefault(w => w.Type == JwtClaimTypes.Role);
                _currentTenant.TenantCode = subject.Value;
            }
            else  //internal
            {
                _currentTenant.TenantCode = httpContextAccessor.HttpContext.Request.Headers[ConstString.CurrentTenantCode].FirstOrDefault();
            }
            return _currentTenant;
        }

    }


}
