

using IdentityModel;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using Aurora.Infrastructure.User;

namespace Aurora.Common.User
{
    public class CurrentUserProvider : ICurrentUserProvider
    {
        IHttpContextAccessor httpContextAccessor;
        IConfiguration _configuration;
        public CurrentUserProvider(IHttpContextAccessor _httpContextAccessor, IConfiguration configuration)
        {
            httpContextAccessor = _httpContextAccessor;
            _configuration = configuration;
        }

        public ICurrentUser GetCurrentUser()
        {
            ICurrentUser currentUser = new CurrentUser();
            if (httpContextAccessor.HttpContext == null) //cap
            {
                currentUser.UserCode = "cap";
                currentUser.UserName = "cap";
            }
            else if (httpContextAccessor.HttpContext.User != null &&
                httpContextAccessor.HttpContext.User.Identity.IsAuthenticated) //external
            {
                ClaimsPrincipal claimsPrincipal = httpContextAccessor.HttpContext.User;
                var subject = claimsPrincipal.Claims.FirstOrDefault(w => w.Type == JwtClaimTypes.Subject);

                var subjectRole = claimsPrincipal.Claims.FirstOrDefault(w => w.Type == JwtClaimTypes.Role);
                currentUser = GetCurrentUserFromRedis(subject.Value, subjectRole.Value);
            }
            else  //internal
            {
                currentUser.UserCode = "internal";
                currentUser.UserName = "internal";
            }
            return currentUser;
        }

        private ICurrentUser GetCurrentUserFromRedis(string usercode, string tenantCode)
        {
            // var redisUserInfo = new CacheRedis(RedisDBType.User, _configuration).GetJSON<CurrentUserInfo>($"{tenantCode}:{usercode}");
            return new CurrentUser();
            // return redisUserInfo;
        }
    }
}