# Aurora

基于 dotnet5 轻量级，微服务化，模块化，插件化，前后端分离快速开发框架
支持多租户，数据库读写分离，容器化部署


## 各个微服务项目说明

* Auth 认证服务 （IdentityServer4）
* Consul 服务发现，注册中心，配置中心
* CoreApi 接口服务（WebApi）
* Gateway 网关服务 (Ocelot)
* Storage 存储服务（存各种文件，预览，转换，导入，导出各种文件,存储用对象存储实现，例如 minio）
* WebHost 前端页面 （Blazor WebAssembly App）

### 示例项目围绕答题系统进行实现

### 计划功能

* 租户管理
* 用户管理
* 分类管理
* 试题录入/导入
* 答案录入/导入
* 答案判断
* 得分统计
* 奖励相关？？？


* 数据库用 mysql 为主（支持SqlServer），适当引入 pgsql
* 考虑引入 ES 实现搜索相关
* 推荐系统相关的知识目前不明确，后续考虑添加 

* 适时适当的加入热门技术，聚集有兴趣的小伙伴一起开发维护，例如 微服务,websocket,rpc,IdentityServer4,ES,docker,k8s,EF,redis,mysql ……

## 项目计划

* 完善当前版本……
* 基本框架完善后，分别加入 本机部署方案， docker-compose 部署方案，k8s 部署方案
* 合理调整项目，制作 CLI 模板
* 发布 0.1 版本到 nuget
* 创建新分支，以支持不同的技术栈支持，如：不同 ORM，不同的前端Demo，不同的注册中心、配置中心等
* 基于本微服务框架实现具体的业务应用，如：英语单词PC-移动端实时同步系统，内容采集系统，内容推荐系统，数据智能报表服务，文件转换预览服务，消息中心服务，定时任务服务
* 做一个Java版的类似以上实现的版本

